#include "page_queue.h"



void PageQueue::discard(Queue &queue, Memory *memory)
{
    while (!queue.empty())
    {
        Flexpage *flexpage = queue.front().flexpage;

        queue.pop_front();
        memory->release(flexpage->region);
        delete flexpage;
    }
}

bool PageQueue::remove(Queue &queue, Positions &positions, PageOwner *owner, Flexpage *flexpage)
{
    Positions::iterator position = positions.find(flexpage);

    if (position == positions.end())
        return false;

    /* The found owner may be different from the requesting owner or even NULL
       if another owner has acquired and then purged its pages. Such a purged
       flexpage is not immediately usable, however. */

    Queue::iterator entry = position->second;

    if ((entry->owner == NULL) || (entry->owner != owner))
        return false;

    queue.erase(entry);
    positions.erase(position);

    return true;
}

// vim: tabstop=4 expandtab shiftwidth=4
